Index: trunk/essentials/sys-libs/zlib/Makefile.kmk
===================================================================
--- trunk/essentials/sys-libs/zlib/Makefile.kmk	(revision 3316)
+++ trunk/essentials/sys-libs/zlib/Makefile.kmk	(revision 3316)
@@ -0,0 +1,156 @@
+# $Id: kNIX-bootstrap.kmk 3073 2007-04-09 00:14:03Z bird $
+## @file
+#
+# kNIX Makefile for zlib
+#
+# Copyright (c) 2007 knut st. osmundsen <bird-src-spam@anduin.net>
+#
+#
+# This file is part of kLIBC.
+#
+# kLIBC is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# kLIBC is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with kLIBC; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+#
+
+DEPTH = ../../..
+include $(PATH_KBUILD)/header.kmk
+
+#
+# libz_s - static.
+#
+LIBRARIES += libz_s
+libz_s_TEMPLATE = usr.lib
+libz_s_SOURCES = \
+	adler32.c \
+	compress.c\
+	crc32.c \
+	gzio.c \
+	uncompr.c \
+	deflate.c \
+	trees.c \
+	zutil.c \
+	inflate.c \
+	infback.c \
+	inftrees.c \
+	inffast.c
+
+#
+# libz_dll - dynamic import library.
+#
+LIBRARIES += libz_dll
+libz_dll_TEMPLATE = usr.lib
+libz_dll_SOURCES = \
+	$(PATH_TARGET)/libz.def
+libz_dll_CLEAN = \
+	$(PATH_TARGET)/libz.def
+
+#
+# libz_dll - dynamic.
+#
+DLLS += kz123
+kz123_TEMPLATE = usr.lib
+kz123_DEFS = ZLIB_DLL
+kz123_SOURCES = \
+	adler32.c \
+	compress.c\
+	crc32.c \
+	gzio.c \
+	uncompr.c \
+	deflate.c \
+	trees.c \
+	zutil.c \
+	inflate.c \
+	infback.c \
+	inftrees.c \
+	inffast.c \
+	$(PATH_TARGET)/libz.def
+
+$(PATH_TARGET)/libz.def: Makefile.kmk
+	$(RM) -f $@
+	$(APPEND) $@ "LIBRARY kz123 INITINSTANCE TERMINSTANCE"
+	$(APPEND) $@ "DATA MULTIPLE NONSHARED"
+	$(APPEND) $@ "EXPORTS"
+	$(APPEND) $@ "    _adler32                           @1"
+	$(APPEND) $@ "    _compress                          @2"
+	$(APPEND) $@ "    _crc32                           	@3"
+	$(APPEND) $@ "    _deflate                           @4"
+	$(APPEND) $@ "    _deflateCopy                       @5"
+	$(APPEND) $@ "    _deflateEnd                        @6"
+	$(APPEND) $@ "    _deflateInit2_                     @7"
+	$(APPEND) $@ "    _deflateInit_                      @8"
+	$(APPEND) $@ "    _deflateParams                     @9"
+	$(APPEND) $@ "    _deflateReset                      @10"
+	$(APPEND) $@ "    _deflateSetDictionary              @11"
+	$(APPEND) $@ "    _gzclose                           @12"
+	$(APPEND) $@ "    _gzdopen                           @13"
+	$(APPEND) $@ "    _gzerror                           @14"
+	$(APPEND) $@ "    _gzflush                           @15"
+	$(APPEND) $@ "    _gzopen                            @16"
+	$(APPEND) $@ "    _gzread                            @17"
+	$(APPEND) $@ "    _gzwrite                           @18"
+	$(APPEND) $@ "    _inflate                           @19"
+	$(APPEND) $@ "    _inflateEnd                        @20"
+	$(APPEND) $@ "    _inflateInit2_                     @21"
+	$(APPEND) $@ "    _inflateInit_                      @22"
+	$(APPEND) $@ "    _inflateReset                      @23"
+	$(APPEND) $@ "    _inflateSetDictionary              @24"
+	$(APPEND) $@ "    _inflateSync                       @25"
+	$(APPEND) $@ "    _uncompress                        @26"
+	$(APPEND) $@ "    _zlibVersion                       @27"
+	$(APPEND) $@ "    _gzprintf                          @28"
+	$(APPEND) $@ "    _gzputc                            @29"
+	$(APPEND) $@ "    _gzgetc                            @30"
+	$(APPEND) $@ "    _gzseek                            @31"
+	$(APPEND) $@ "    _gzrewind                          @32"
+	$(APPEND) $@ "    _gztell                            @33"
+	$(APPEND) $@ "    _gzeof                             @34"
+	$(APPEND) $@ "    _gzsetparams                       @35"
+	$(APPEND) $@ "    _zError                            @36"
+	$(APPEND) $@ "    _inflateSyncPoint                  @37"
+	$(APPEND) $@ "    _get_crc_table                     @38"
+	$(APPEND) $@ "    _compress2                         @39"
+	$(APPEND) $@ "    _gzputs                            @40"
+	$(APPEND) $@ "    _gzgets                            @41"
+
+#
+# Install headers.
+#
+INSTALLS += libz-headers
+libz-headers_TEMPLATE = usr.include
+libz-headers_SOURCES = \
+	zlib.h \
+	zconf.h
+
+#
+# The man page.
+#
+INSTALLS += libz-manpages
+libz-manpages_TEMPLATE = usr.bin.man
+libz-manpages_SOURCES = \
+	zlib.3
+
+#
+# Documentation.
+#
+INSTALLS += libz-docs
+libz-docs_TEMPLATE = usr.bin.doc
+libz-docs_SOURCES = \
+	FAQ \
+	README \
+	ChangeLog \
+	algorithm.txt
+
+include $(PATH_KBUILD)/footer.kmk
+