Index: trunk/src/oleaut32/itypeinfo.cpp
===================================================================
--- trunk/src/oleaut32/itypeinfo.cpp	(revision 3321)
+++ trunk/src/oleaut32/itypeinfo.cpp	(revision 3324)
@@ -1,3 +1,3 @@
-/* $Id: itypeinfo.cpp,v 1.2 2000-03-21 08:17:22 davidr Exp $ */
+/* $Id: itypeinfo.cpp,v 1.3 2000-04-05 22:28:47 davidr Exp $ */
 /* 
  * ITypeInfo interface
@@ -977,5 +977,8 @@
 
 	if (!pCustData->prgCustData)
+	{
+	    dprintf(("OLEAUT32: GetAllCustData: E_OUTOFMEMORY"));
 	    return E_OUTOFMEMORY;
+	}
 
 	int		index = 0;
Index: trunk/src/oleaut32/itypelib.cpp
===================================================================
--- trunk/src/oleaut32/itypelib.cpp	(revision 3321)
+++ trunk/src/oleaut32/itypelib.cpp	(revision 3324)
@@ -1,3 +1,3 @@
-/* $Id: itypelib.cpp,v 1.2 2000-03-21 08:17:22 davidr Exp $ */
+/* $Id: itypelib.cpp,v 1.3 2000-04-05 22:28:48 davidr Exp $ */
 /* 
  * ITypelib interface
@@ -588,5 +588,8 @@
     if ((pItem = (CUSTDATAITEM *)HeapAlloc(GetProcessHeap(), 0,
 			    sizeof(CUSTDATAITEM) * This->pCustData.Count())) == 0)
+    {
+	dprintf(("OLEAUT32: ITypeLib2Impl_GetAllCustData: E_OUTOFMEMORY"));
         return E_OUTOFMEMORY;
+    }
 
     pCustData->prgCustData = pItem;
Index: trunk/src/oleaut32/ole2disp.cpp
===================================================================
--- trunk/src/oleaut32/ole2disp.cpp	(revision 3321)
+++ trunk/src/oleaut32/ole2disp.cpp	(revision 3324)
@@ -1,3 +1,3 @@
-/* $Id: ole2disp.cpp,v 1.2 1999-08-22 22:08:47 sandervl Exp $ */
+/* $Id: ole2disp.cpp,v 1.3 2000-04-05 22:28:48 davidr Exp $ */
 /*
  *	OLE2DISP library
@@ -228,5 +228,5 @@
   BYTE b = HIBYTE(HIWORD(clr));
 
-  TRACE("(%08lx, %d, %p):stub\n", clr, hpal, pColorRef);
+  TRACE("OleTranslateColor(%08lx, %d, %p)\n", clr, hpal, pColorRef);
 
   /*
Index: trunk/src/oleaut32/stubs.cpp
===================================================================
--- trunk/src/oleaut32/stubs.cpp	(revision 3321)
+++ trunk/src/oleaut32/stubs.cpp	(revision 3324)
@@ -1,3 +1,3 @@
-/* $Id: stubs.cpp,v 1.5 2000-01-05 18:29:54 davidr Exp $ */
+/* $Id: stubs.cpp,v 1.6 2000-04-05 22:28:48 davidr Exp $ */
 /* 
  * Win32 COM/OLE stubs for OS/2
@@ -10,5 +10,5 @@
  * 
  */
- 
+
 #include "oleaut32.h"
 
Index: trunk/src/oleaut32/typelib.cpp
===================================================================
--- trunk/src/oleaut32/typelib.cpp	(revision 3321)
+++ trunk/src/oleaut32/typelib.cpp	(revision 3324)
@@ -1,3 +1,3 @@
-/* $Id: typelib.cpp,v 1.12 2000-03-24 08:34:14 davidr Exp $ */
+/* $Id: typelib.cpp,v 1.13 2000-04-05 22:28:48 davidr Exp $ */
 /* 
  * ITypelib interface
@@ -260,5 +260,5 @@
 // ======================================================================
 
-#if defined(DEBUG)
+#if defined(DEBUG2)
 
 // ----------------------------------------------------------------------
@@ -1100,5 +1100,5 @@
     }
 
-#if defined(DEBUG)	    
+#if defined(DEBUG2)	    
     dprintfLine2();
     dprintf((LOG, "TypeInfo        %s", pTypeInfo->szName));
@@ -1153,5 +1153,5 @@
     ParseCustomData(pBase->oCustData, &pTypeInfo->pCustData);
 
-#if defined(DEBUG)	    
+#if defined(DEBUG2)	    
     dprintfLine();
 #endif
@@ -1366,5 +1366,5 @@
 	    ParseCustomData(pCustomOff[0], &pNew->pCustData);
 
-#if defined(DEBUG)
+#if defined(DEBUG2)
 	{
 	dprintfLine();
@@ -1416,5 +1416,5 @@
 #endif // 0
 	}
-#endif // defined(DEBUG)
+#endif // defined(DEBUG2)
 
         // do the parameters/arguments 
@@ -1456,5 +1456,5 @@
                     ParseCustomData(pCustomOff[1 + jj], &pNew->pParamDesc[jj].pCustData);
 
-#if defined(DEBUG)
+#if defined(DEBUG2)
 	dprintfLine();
 	dprintf((LOG, "Parameter       \"%s\"\n", pNew->pParamDesc[jj].szName));
@@ -1538,5 +1538,5 @@
             V_UNION(&(pNew->vardesc), oInst) = pVarRec->OffsValue;
 
-#if defined(DEBUG)
+#if defined(DEBUG2)
 	{
 	dprintfLine();
@@ -1564,5 +1564,5 @@
         }
 
-#endif // defined(DEBUG)
+#endif // defined(DEBUG2)
 
 	// Store
@@ -1731,5 +1731,8 @@
     // Create new typelib object...
     if ((m_pITypeLib = ITypeLibImpl_Constructor()) == 0)
+    {
+	dprintfGlobal(("OLEAUT32: TypeLibExtract::MakeITypeLib: E_OUTOFMEMORY"));
     	return E_OUTOFMEMORY;
+    }
 
     // Parse the typelib into storeage independent format.
@@ -1773,5 +1776,5 @@
 	ParseString(*m_pHelpStringOff, &m_pITypeLib->szHelpStringDll);
 
-#if defined(DEBUG)
+#if defined(DEBUG2)
 
     dprintfLine2();
@@ -1857,5 +1860,5 @@
 	    }
 
-#if defined(DEBUG)	    
+#if defined(DEBUG2)	    
 	    dprintfLine2();
 	    dprintf((LOG, "TypeDesc:       %i", ii));
@@ -1909,5 +1912,5 @@
             totLen += recLen;
             pImpFile = (TLBImpFile *)((char *)pImpFile + recLen);
-#if defined(DEBUG)	    
+#if defined(DEBUG2)	    
 	    dprintfLine2();
 	    dprintf((LOG, "ImpLib %i", pNew->offset));