Index: trunk/kBuild/tools/VCC141.kmk
===================================================================
--- trunk/kBuild/tools/VCC141.kmk	(revision 3340)
+++ trunk/kBuild/tools/VCC141.kmk	(revision 3342)
@@ -108,5 +108,9 @@
 TOOL_VCC141_CC      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141_BIN_QSH)/cl.exe
 TOOL_VCC141_CXX     ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141_BIN_QSH)/cl.exe
+ifeq ($(KBUILD_TARGET_ARCH),x86)
+TOOL_VCC141_AS      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141_BIN_QSH)/ml.exe
+else
 TOOL_VCC141_AS      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141_BIN_QSH)/ml64.exe
+endif
 #TOOL_VCC141_AR      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141_BIN_QSH)/lib.exe - just an exec wrapper for the below
 TOOL_VCC141_AR      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141_BIN_QSH)/link.exe /LIB
@@ -177,32 +181,32 @@
 # @param 3 The VCC architecture name (for constructing the path).
 FN_TOOL_VCC141_FIND_DLLS = $(2).dll \
-	$(sortfiles $(qnotdir ,$(qwildcard ,$(PATH_TOOL_VCC142_REDIST)/$(3)/$(1)/$(2)_?.dll)))
+	$(sortfiles $(qnotdir ,$(qwildcard ,$(PATH_TOOL_VCC141_REDIST)/$(3)/$(1)/$(2)_?.dll)))
 
 TOOL_VCC141_REDIST_CRT_SUBDIR       := Microsoft.VC141.CRT
 TOOL_VCC141_REDIST_DEBUG_CRT_SUBDIR := Microsoft.VC141.DebugCRT
 
-TOOL_VCC142_REDIST_CRT_DLLS.x86      = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),vcruntime140,x86)
-TOOL_VCC142_REDIST_CRT_DLLS.amd64    = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),vcruntime140,x64)
-TOOL_VCC142_REDIST_CRT_DLLS.arm32    = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),vcruntime140,arm)
-TOOL_VCC142_REDIST_CRT_DLLS.arm64    = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),vcruntime140,arm64)
-TOOL_VCC142_REDIST_CRT_DLLS          = $(TOOL_VCC142_REDIST_CRT_DLLS.$(KBUILD_TARGET_ARCH))
-
-TOOL_VCC142_REDIST_CONCRT_DLLS.x86   = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),concrt140,x86)
-TOOL_VCC142_REDIST_CONCRT_DLLS.amd64 = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),concrt140,x64)
-TOOL_VCC142_REDIST_CONCRT_DLLS.arm32 = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),concrt140,arm)
-TOOL_VCC142_REDIST_CONCRT_DLLS.arm64 = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),concrt140,arm64)
-TOOL_VCC142_REDIST_CONCRT_DLLS       = $(TOOL_VCC142_REDIST_CONCRT_DLLS.$(KBUILD_TARGET_ARCH))
-
-TOOL_VCC142_REDIST_CPP_DLLS.x86      = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),msvcp140,x86)
-TOOL_VCC142_REDIST_CPP_DLLS.amd64    = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),msvcp140,x64)
-TOOL_VCC142_REDIST_CPP_DLLS.arm32    = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),msvcp140,arm)
-TOOL_VCC142_REDIST_CPP_DLLS.arm64    = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),msvcp140,arm64)
-TOOL_VCC142_REDIST_CPP_DLLS          = $(TOOL_VCC142_REDIST_CPP_DLLS.$(KBUILD_TARGET_ARCH))
-
-TOOL_VCC142_REDIST_WINRT_DLLS.x86    = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),vccorlib140,x86)
-TOOL_VCC142_REDIST_WINRT_DLLS.amd64  = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),vccorlib140,x64)
-TOOL_VCC142_REDIST_WINRT_DLLS.arm32  = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),vccorlib140,arm)
-TOOL_VCC142_REDIST_WINRT_DLLS.arm64  = $(call FN_TOOL_VCC142_FIND_DLLS,$(TOOL_VCC142_REDIST_CRT_SUBDIR),vccorlib140,arm64)
-TOOL_VCC142_REDIST_WINRT_DLLS        = $(TOOL_VCC142_REDIST_WINRT_DLLS.$(KBUILD_TARGET_ARCH))
+TOOL_VCC141_REDIST_CRT_DLLS.x86      = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),vcruntime140,x86)
+TOOL_VCC141_REDIST_CRT_DLLS.amd64    = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),vcruntime140,x64)
+TOOL_VCC141_REDIST_CRT_DLLS.arm32    = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),vcruntime140,arm)
+TOOL_VCC141_REDIST_CRT_DLLS.arm64    = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),vcruntime140,arm64)
+TOOL_VCC141_REDIST_CRT_DLLS          = $(TOOL_VCC141_REDIST_CRT_DLLS.$(KBUILD_TARGET_ARCH))
+
+TOOL_VCC141_REDIST_CONCRT_DLLS.x86   = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),concrt140,x86)
+TOOL_VCC141_REDIST_CONCRT_DLLS.amd64 = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),concrt140,x64)
+TOOL_VCC141_REDIST_CONCRT_DLLS.arm32 = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),concrt140,arm)
+TOOL_VCC141_REDIST_CONCRT_DLLS.arm64 = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),concrt140,arm64)
+TOOL_VCC141_REDIST_CONCRT_DLLS       = $(TOOL_VCC141_REDIST_CONCRT_DLLS.$(KBUILD_TARGET_ARCH))
+
+TOOL_VCC141_REDIST_CPP_DLLS.x86      = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),msvcp140,x86)
+TOOL_VCC141_REDIST_CPP_DLLS.amd64    = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),msvcp140,x64)
+TOOL_VCC141_REDIST_CPP_DLLS.arm32    = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),msvcp140,arm)
+TOOL_VCC141_REDIST_CPP_DLLS.arm64    = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),msvcp140,arm64)
+TOOL_VCC141_REDIST_CPP_DLLS          = $(TOOL_VCC141_REDIST_CPP_DLLS.$(KBUILD_TARGET_ARCH))
+
+TOOL_VCC141_REDIST_WINRT_DLLS.x86    = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),vccorlib140,x86)
+TOOL_VCC141_REDIST_WINRT_DLLS.amd64  = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),vccorlib140,x64)
+TOOL_VCC141_REDIST_WINRT_DLLS.arm32  = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),vccorlib140,arm)
+TOOL_VCC141_REDIST_WINRT_DLLS.arm64  = $(call FN_TOOL_VCC141_FIND_DLLS,$(TOOL_VCC141_REDIST_CRT_SUBDIR),vccorlib140,arm64)
+TOOL_VCC141_REDIST_WINRT_DLLS        = $(TOOL_VCC141_REDIST_WINRT_DLLS.$(KBUILD_TARGET_ARCH))
 
 TOOL_VCC141_REDIST_CXXAMP_SUBDIR := Microsoft.VC141.CXXAMP
Index: trunk/kBuild/tools/VCC141X86.kmk
===================================================================
--- trunk/kBuild/tools/VCC141X86.kmk	(revision 3340)
+++ trunk/kBuild/tools/VCC141X86.kmk	(revision 3342)
@@ -82,5 +82,5 @@
 TOOL_VCC141X86_CC      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141X86_BIN_QSH)/cl.exe
 TOOL_VCC141X86_CXX     ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141X86_BIN_QSH)/cl.exe
-TOOL_VCC141X86_AS      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141X86_BIN_QSH)/ml64.exe
+TOOL_VCC141X86_AS      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141X86_BIN_QSH)/ml.exe
 #TOOL_VCC141X86_AR      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141X86_BIN_QSH)/lib.exe - just an exec wrapper for the below
 TOOL_VCC141X86_AR      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC141X86_BIN_QSH)/link.exe /LIB
Index: trunk/kBuild/tools/VCC142.kmk
===================================================================
--- trunk/kBuild/tools/VCC142.kmk	(revision 3340)
+++ trunk/kBuild/tools/VCC142.kmk	(revision 3342)
@@ -108,5 +108,9 @@
 TOOL_VCC142_CC      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142_BIN_QSH)/cl.exe
 TOOL_VCC142_CXX     ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142_BIN_QSH)/cl.exe
+ifeq ($(KBUILD_TARGET_ARCH),x86)
+TOOL_VCC142_AS      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142_BIN_QSH)/ml.exe
+else
 TOOL_VCC142_AS      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142_BIN_QSH)/ml64.exe
+endif
 #TOOL_VCC142_AR      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142_BIN_QSH)/lib.exe - just an exec wrapper for the below
 TOOL_VCC142_AR      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142_BIN_QSH)/link.exe /LIB
Index: trunk/kBuild/tools/VCC142X86.kmk
===================================================================
--- trunk/kBuild/tools/VCC142X86.kmk	(revision 3340)
+++ trunk/kBuild/tools/VCC142X86.kmk	(revision 3342)
@@ -82,5 +82,5 @@
 TOOL_VCC142X86_CC      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142X86_BIN_QSH)/cl.exe
 TOOL_VCC142X86_CXX     ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142X86_BIN_QSH)/cl.exe
-TOOL_VCC142X86_AS      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142X86_BIN_QSH)/ml64.exe
+TOOL_VCC142X86_AS      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142X86_BIN_QSH)/ml.exe
 #TOOL_VCC142X86_AR      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142X86_BIN_QSH)/lib.exe - just an exec wrapper for the below
 TOOL_VCC142X86_AR      ?= $(EXEC_X86_WIN32) $(PATH_TOOL_VCC142X86_BIN_QSH)/link.exe /LIB